"""
DOM zpracování dokumentu:
Program zjistí jména všech druhů ovoce z XML dokumentu, který je zadán jako parametr skriptu
a ukládá je do seznamu, který vytiskne na standardní výstup.
"""

import sys, string

# Import modulu pro tvorbu stromové struktury a uzlů stromu
from xml.dom import minidom, Node

nameList = []		                                  # Seznam jmen


# Funkce pro běh programu
def run(inFileName):    
    outFile = sys.stdout                                  # Standardní vystup    
    doc = minidom.parse(inFileName)                       # Parsování dokumentu a vytvoření stromové struktury    
    rootNode = doc.documentElement                        # Nastavení kořene stromu na documentElement    
    ovoce = rootNode.getElementsByTagName("ovoce")        # Vytvoření seznamu elementu <ovoce>
    
    if len(ovoce) == 1:                                   # Test zda je jen jeden        
        items = ovoce[0].getElementsByTagName("polozka")  # Vytvoření seznamu elementů <polozka>        
        for item in items:                                # Průchod seznamem            
            names = item.getElementsByTagName("nazev")    # Vytvoření seznamu elementů <nazev>            
            if len(names) == 1:                           # Test zda je jen jeden
                ovoceName = ''                            # Proměnná pro uchování názvu ovoce
                for child in names[0].childNodes:         # Průchod seznamem bezprostředních následovníků elementů <nazev>                    
                    if child.nodeType == Node.TEXT_NODE:  # Skládání názvu ovoce z uzlů typu TEXT_NODE
                        ovoceName = ovoceName + child.nodeValue
                nameList.append(ovoceName)                # Vložení názvu ovoce na konec seznamu jmen
    else:
        outFile.write("Ovoce není objednané!\n")
            
    printList(outFile, nameList)                          # Tisk seznamu jmen        

def printList(outfile, nameList):                         # Funkce pro tisk seznamu
    outfile.write("V objednávce je {0:d} druhů ovoce:\n".format(len(nameList)))
    for name in nameList:
        outfile.write(" {0:s}\n".format(name))

def main():                                               # Funkce pro test počtů vstupních parametrů
    args = sys.argv[1:]

    if len(args) != 1:
        print('Pro spuštění zadejte: python dom_elementy.py jidlo.xml')
        sys.exit(-1)

    run(args[0])

main()
