'''
Převod TXT na XML bez použití knihoven:
Program převede data ze souboru TXT, který má předem známou strukturu.
XML souboru se musí vytvořit podle určité předepsané struktury elementů a atributů.
Pro větší obtížnost byla zvolena forma s atributy, aby byl příklad názornější.
Při volbě elementů by stačilo pouze nahradit sekvenci znaků jinou sekvencí,
která by odpovídala názvu počáteční a koncové značky elementu.
'''

# Pomocné indexy pro dodržení předdefinované struktury
indexes = [0, 2, 1, 3, 4, 5]

# Seznam pro ukládání údajů o jednotlivých osobách
people = []

# Funkce se spustí příkazem create_xml(txt, xml), kde
# txt = jméno textového zdrojového souboru např. databaze.txt
# xml = jméno xml výstupního souboru např. databaze.xml
def create_xml(txt, xml):
  file_txt = open(txt, "r")
  file_xml = open(xml, "w")
  
  for line in file_txt.readlines():
    line = line.rstrip("\n")
    people.append(line.split(';'))
    
  # Zápis hlavičky XML dokumentu a značky kořenového elementu
  file_xml.write('<?xml version="1.0" encoding="UTF-8"?>\n\n')
  file_xml.write('<people>\n')
  
  # Cyklus zpracovávající jednotlivé osoby
  for person in people:
    for ind in indexes:
      if person[ind] != '':
        if ind == 0:
          file_xml.write('  <person id="{0:s}"'.format(person[ind]))
        elif ind == 2:
          file_xml.write(' sex="{0:s}">\n'.format(person[ind]))
        elif ind == 1:
          file_xml.write('    <name>{0:s}</name>\n'.format(person[ind]))
        elif ind == 3:
          file_xml.write('    <mother>{0:s}</mother>\n'.format(person[ind]))
        elif ind == 4:
          file_xml.write('    <father>{0:s}</father>\n'.format(person[ind]))
        else:
          file_xml.write('    <partner>{0:s}</partner>\n'.format(person[ind]))
          
    file_xml.write('  </person>\n')
  
  file_xml.write('</people>')
  file_xml.close()
  file_txt.close()

# Volání funkce s přednastavenými jmény souborů
create_xml("databaze.txt", "databaze.xml")
